<?php
# **********************************************************************************************
# bw_phpLivePacker
#
# (c) 2013 Christian Bartl (phplivepacker.bartlweb.net)
#
# This extension is part of the phpLivePacker open source project.
# The phpLivePacker project is licensed under the GNU General Public License.
#
# This notice must appear in all copies of the script.
# **********************************************************************************************

class BwPhplivepacker {
	

/* ------------------------------------------------------------------------------------------------------------
   main function
------------------------------------------------------------------------------------------------------------ */
	
	public static function clearCache(){
		
		// read extension configuration		
		$conf = unserialize($GLOBALS['TYPO3_CONF_VARS']['EXT']['extConf']['bw_phplivepacker']);
		$conf = is_array($conf) ? $conf : array();		
		
		// clear cache directory
		BwPhplivepacker::clearCacheDirectory($conf);		
		
		// increase phplivepacker constant
		BwPhplivepacker::incrementConstant($conf);


		return void;
	}


/* ------------------------------------------------------------------------------------------------------------
   clear phplivepacker cache directory
------------------------------------------------------------------------------------------------------------ */

	public static function clearCacheDirectory($conf) {
		// check if directory is configured
		if(!$conf['cacheDirectory']) {
			return false;
		}
		
		// generate full path
		$path = trim(trim($conf['cacheDirectory']), '/');
		$path = PATH_site . $path  . '/';
		
		if(preg_match('/^Windows/', $_ENV['OS']) || $_SERVER['WINDIR']) {
			$path = str_replace('/', '\\', $path);
		} else {
			$path = str_replace('\\', '/', $path);
		}

		// check on path traversal
		if(strpos('..', $path)) {
			return false;
		}
		
		// check if directory exists
		if(!is_dir($path)) {
			return false;
		}
		
		// check if directory is writeable
		if(!is_writeable($path)) {
			return false;
		}
	
		// delete all files except .htaccess and .htpasswd
		foreach(glob($path.'*') as $file){
			if(!preg_match('/\.htaccess/', $file) && !preg_match('/\.htpasswd$/', $file)) {
				unlink($file);
			}
		}
		
		
		return true;
	}


/* ------------------------------------------------------------------------------------------------------------
   increment phplivepacker constant
------------------------------------------------------------------------------------------------------------ */
	
	public static function incrementConstant($conf) {
		
		// check if version increment is enabled
		if(!$conf['enableVersionIncrement']) {
			return true;
		}
		
		// check if file is configured
		if(!$conf['tsFile']) {
			return false;
		}
		
		// generate full path
		$path = trim(trim($conf['tsFile']), '/');
		$path = PATH_site . $path;
		
		if(preg_match('/^Windows/', $_ENV['OS']) || $_SERVER['WINDIR']) {
			$path = str_replace('/', '\\', $path);
		} else {
			$path = str_replace('\\', '/', $path);
		}

		// check on path traversal
		if(strpos('..', $path)) {
			return false;
		}

		// check if file exists
		if(!is_file($path)) {
			return false;
		}

		// check if file is readable and writeable
		if(!is_readable($path) || !is_writeable($path)) {
			return false;
		}
	
		// parse file and increment constant
		$content = file_get_contents($path);
		$content_lines = explode("\n", $content);
		
		foreach($content_lines as $i => $line) {
			if(preg_match('/^\s*' . $conf['versionConstant'] . '/', $line)) {
				$tmp = explode("=", $line);
				$line = $tmp[0] . '= ' . (intval($tmp[1])+1);
				$content_lines[$i] = $line;
			}
		}
		
		file_put_contents($path, implode("\n", $content_lines));
		
		// clear frontend cache
		$TCE = t3lib_div::makeInstance('t3lib_TCEmain');
		$TCE->admin = 1;
		$TCE->clear_cacheCmd('pages');
		
		
		return true;
	}

}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/vc_phplivepacker/class.tx_vcphplivepacker.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/vc_phplivepacker/class.tx_vcphplivepacker.php']);
}
?>